# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import re

words = {0:'Zero',1:'One',2:'Two', 3:'Three',4:'Four',5:'Five',6:'Six',7:'Seven',8:'Eight',9:'Nine',10:'Ten',11:'Eleven',12:"Twelve",13:"Thirteen",14:'Fourteen',15:'Fifteen',16:'Sixteen',17:'Seventeen',18:'Eighteen',19:'Nineteen'}
tens = {1:"Ten",2:"Twenty",3:"Thirty",4:"Forty",5:"Fifty",6:'Sixty',7:"Seventy",8:"Eighty",9:'Ninty',0:""}

def char_to_word(st):
    """
        Its developed still 99,99,99,999.
        You can do it more..
    """
    chars = []
    st = str(st)
    st = re.sub(r'\D', "", st)
    for s in st:
        chars.append(s)
    chars.reverse()
    strings = []
    previous = False
    for i,c in enumerate(chars):
        if i == 0:
            previous = c
            strings.append(words[int(c)])
        if i == 1:
            if c == "1" and previous != '0':
                strings = strings[:-1]
                strings.append(words[int(c+previous)])
            else:
                if previous == '0':
                    strings = strings[:-1]
                strings.append(tens[int(c)])
                
        if i == 2:
            if c != '0':
                strings.append("Hundred")
                strings.append(words[int(c)])
            
        if i == 3:
            strings.append("Thousand")
            previous = c
            strings.append(words[int(c)])
        if i == 4:
            if c == "1":
                strings = strings[:-1]
                strings.append(words[int(c+previous)])
                previous =False
            else:
                if previous == '0':
                    strings = strings[:-1]
                    if c == '0':
                        strings = strings[:-1]
                strings.append(tens[int(c)])

        if i == 5:
            strings.append("Lakh")
            previous = c
            strings.append(words[int(c)])
        if i == 6:
            if c == "1":
                strings = strings[:-1]
                strings.append(words[int(c+previous)])
                previous =False
            else:
                if previous == '0':
                    strings = strings[:-1]
                    if c == '0':
                        strings = strings[:-1]
                strings.append(tens[int(c)])
        
        if i == 7:
            strings.append("Crore")
            previous = c
            strings.append(words[int(c)])
        if i == 8:
            if c == "1":
                strings = strings[:-1]
                strings.append(words[int(c+previous)])
                previous =False
            else:
                if previous == '0':
                    strings = strings[:-1]
                    if c == '0':
                        strings = strings[:-1]
                strings.append(tens[int(c)])
    strings.reverse()
    #print st, re.sub( '\s+', ' ', " ".join(strings)).strip()
    return re.sub( '\s+', ' ', " ".join(strings)).strip()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
